//Initialisierung 7 Segmentanzeigen
#include "TM1637.h"
#define CH1CLK 4//pins definitions for Display from Channel 1       
#define CH1DIO 5
TM1637 mydisp(CH1CLK,CH1DIO);
#define CH2CLK 8//pins definitions for Display from Channel 2      
#define CH2DIO 9
TM1637 mydisp2(CH2CLK,CH2DIO);
#define CH3CLK 12 //pins definitions for Display from Channel 2        
#define CH3DIO 13
TM1637 mydisp3(CH3CLK,CH3DIO);

// Initialisierung Display I2C
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,20,4);  // set the LCD address to 0x27 for a 16 chars and 2 line display

// Encoder 
 int encoder1PinA = 2;
 int encoder1PinB = 3;
 int encoder1Pos = 0;
 int encoder1PinALast = LOW;
 int encoder1_n = LOW;
 int encoder2PinA = 6;
 int encoder2PinB = 7;
 int encoder2Pos = 0;
 int encoder2PinALast = LOW;
 int encoder2_n = LOW;
 int encoder3PinA = 19;
 int encoder3PinB = 18;
 int encoder3Pos = 0;
 int encoder3PinALast = LOW;
 int encoder3_n = LOW;
 
// Variablen für Anzeige der Encoderwerte im 7 Segment 
int CH1_1000er = 0;
int CH1_100er = 0;
int CH1_10er = 0;
int CH1_1er = 0;
int CH2_1000er = 0;
int CH2_100er = 0;
int CH2_10er = 0;
int CH2_1er = 0;
int CH3_1000er = 0;
int CH3_100er = 0;
int CH3_10er = 0;
int CH3_1er = 0;

// Schalter
// Tastendrücken mehrer Buttons abfragen
const byte buttonPins[]={27,29,31,33,35,37,34,36,38,40,42,44,51,49,47,45,43,41};
const byte buttonPinCount=sizeof(buttonPins);
#define DEBOUNCETIME 10

int buttonPressedMulti()
// returns number of button once a button is pressed
// returns -1 otherwise
{
  boolean State;
  static boolean buttonFired[buttonPinCount];
  static long buttonDownSince[buttonPinCount];
  for (int i=0;i<buttonPinCount;i++)
  {
    State=digitalRead(buttonPins[i]);
    if (State==LOW)  
    { // this button is not pressed at this time
      buttonFired[i]=false;
      buttonDownSince[i]=0;
    }
    else if (State==HIGH && buttonDownSince[i]==0)
    { // button is pressed but DEBOUNCETIME did not yet started counting
      buttonFired[i]=false;
      buttonDownSince[i]=millis();
    }
    if (State==HIGH && millis()-buttonDownSince[i]>=DEBOUNCETIME && buttonFired[i]==false)
    { // button is pressed and DEBOUNCETIME passed, so fire the button
      buttonFired[i]=true;
//      return(i); // return pin number in array
      return buttonPins[i]; // return pin number of button 
    }  
  }
  return(-1); // no button fired this time, return invalid pin number
}

//Status für Schalterpositionen
boolean CH1_On_State = 1;
boolean CH1_Pow_State = 1;
boolean CH1_Lamp_State = 0;
boolean CH1_Beep_State = 0;
boolean CH1_Prop_State = 0;

boolean CH2_On_State = 1;
boolean CH2_Pow_State = 1;
boolean CH2_Lamp_State = 0;
boolean CH2_Beep_State = 0;
boolean CH2_Prop_State = 0;

boolean CH3_On_State = 1;
boolean CH3_Pow_State = 1;
boolean CH3_Lamp_State = 0;
boolean CH3_Beep_State = 0;
boolean CH3_Prop_State = 0;

//Variablen für Akkustatus
const int Akkueingang = 1;
int Akkupercent;

//Bluetooth Aufbau
#include <SoftwareSerial.h>   //Software Serial Port

#define RxD 10  
#define TxD 11


String retSymb = "+RTINQ=";//start symble when there's any return
String slaveName = ";SeeedBTSlave";//Set the Slave name ,caution that ';'must be included
int nameIndex = 0;
int addrIndex = 0;

String recvBuf;
String slaveAddr;

String connectCmd = "\r\n+CONN=";

SoftwareSerial blueToothSerial(RxD,TxD);

//Timer
boolean CTR_timer(unsigned long &timer_var, unsigned long time);
unsigned long Alarm_timer = 0;

//Definitionen für auswertung
#define STATE_UNDEFINED 0
#define STATE_READING_KEY 1
#define STATE_READING_VALUE 2
#define STATE_KEEP_ALIVE 3
#define STATE_CALL_SLAVE 4

String BTReceiveParameter;
String BTReceiveValue;
String BTHeartbeat;

String Temp_BTReceiveParameter;
String Temp_BTReceiveValue;
String Temp;

uint8_t currentState = STATE_UNDEFINED; 

void setup()
{
  mydisp.init();
  mydisp.set(3);//BRIGHT_TYPICAL = 2,BRIGHT_DARKEST = 0,BRIGHTEST = 7;
  mydisp2.init();
  mydisp2.set(3);//BRIGHT_TYPICAL = 2,BRIGHT_DARKEST = 0,BRIGHTEST = 7;
  mydisp3.init();
  mydisp3.set(3);//BRIGHT_TYPICAL = 2,BRIGHT_DARKEST = 0,BRIGHTEST = 7;  
  lcd.init();                      // initialize the lcd 
  lcd.init();
  // Print a message to the LCD.
  lcd.backlight();
  lcd.setCursor(2,0);
  lcd.print("Flashcontrol V01");
  lcd.setCursor(5,1);
  lcd.print("Systemstart");
   lcd.setCursor(2,2);
  lcd.print("Initialisierung");
   lcd.setCursor(1,3);
  lcd.print("Flashlights Berlin");
  delay(2500);
  lcd.clear();
  //Encoder
  pinMode (encoder1PinA,INPUT);
  pinMode (encoder1PinB,INPUT);
  pinMode (encoder2PinA,INPUT);
  pinMode (encoder2PinB,INPUT);
  pinMode (encoder3PinA,INPUT);
  pinMode (encoder3PinB,INPUT);
  Serial.begin (9600);
  // Display Startsequenz
    mydisp.display(0,0);
    mydisp.display(1,0); 
    mydisp.display(2,0);
    mydisp.display(3,0);
    
    mydisp2.display(0,0);
    mydisp2.display(1,0); 
    mydisp2.display(2,0);
    mydisp2.display(3,0);
    
    mydisp3.display(0,0);
    mydisp3.display(1,0); 
    mydisp3.display(2,0);
    mydisp3.display(3,0);
 // Button einrichten
  // put your setup code here, to run once:
  Serial.begin(9600);
  for (int i=0;i<buttonPinCount;i++)
  {
    pinMode(buttonPins[i],INPUT);
  }
  
  pinMode(RxD, INPUT);
  pinMode(TxD, OUTPUT);
  setupBlueToothConnection();
  //wait 1s and flush the serial buffer
  delay(1000);
  Serial.flush();
  blueToothSerial.flush();
}

void loop()
{
  //char recvChar;
  //recvChar = blueToothSerial.read();
  // put your main code here, to run repeatedly: 
  int button=buttonPressedMulti();
  if (button>=0)
  {
    Serial.print("Button pressed: ");
    Serial.println(button);
    Channel1(button);
    Channel2(button);
    Channel3(button);
    Statusanzeige();  
  }  
Encoder();
Akkucheck();
BluetoothWork();
//SlaveAlive();
}
